/*
Программа регулировки яркости теплой и холодной LED лент с помощью одного регулятора.
*/

// Яркость - 8 бит, ступени - 256, экспонента - 1,4
byte TAB_BRIGHTS[256] = {
  0 , 0 , 0 , 0 , 0 , 1 , 1 , 1 , 1 , 2 , 2 , 3 , 3 , 3 , 4 , 4 ,
  5 , 5 , 6 , 6 , 7 , 7 , 8 , 8 , 9 , 9 , 10 , 10 , 11 , 12 , 12 , 13 ,
  13 , 14 , 15 , 15 , 16 , 17 , 17 , 18 , 18 , 19 , 20 , 20 , 21 , 22 , 23 , 23 ,
  24 , 25 , 25 , 26 , 27 , 28 , 28 , 29 , 30 , 31 , 31 , 32 , 33 , 34 , 35 , 35 ,
  36 , 37 , 38 , 39 , 39 , 40 , 41 , 42 , 43 , 44 , 44 , 45 , 46 , 47 , 48 , 49 ,
  50 , 50 , 51 , 52 , 53 , 54 , 55 , 56 , 57 , 58 , 59 , 59 , 60 , 61 , 62 , 63 ,
  64 , 65 , 66 , 67 , 68 , 69 , 70 , 71 , 72 , 73 , 74 , 75 , 76 , 77 , 78 , 79 ,
  80 , 81 , 82 , 83 , 84 , 85 , 86 , 87 , 88 , 89 , 90 , 91 , 92 , 93 , 94 , 95 ,
  97 , 98 , 99 , 100 , 101 , 103 , 104 , 105 , 106 , 107 , 108 , 109 , 110 , 111 , 112 , 113 ,
  115 , 116 , 117 , 118 , 119 , 120 , 121 , 122 , 124 , 125 , 126 , 127 , 128 , 129 , 130 , 132 ,
  133 , 134 , 135 , 136 , 137 , 139 , 140 , 141 , 142 , 143 , 144 , 146 , 147 , 148 , 149 , 150 ,
  152 , 153 , 154 , 155 , 156 , 158 , 159 , 160 , 161 , 163 , 164 , 165 , 166 , 167 , 169 , 170 ,
  171 , 172 , 174 , 175 , 176 , 177 , 179 , 180 , 181 , 183 , 184 , 185 , 186 , 188 , 189 , 190 ,
  191 , 193 , 194 , 195 , 197 , 198 , 199 , 201 , 202 , 203 , 204 , 206 , 207 , 208 , 210 , 211 ,
  212 , 214 , 215 , 216 , 218 , 219 , 220 , 222 , 223 , 224 , 226 , 227 , 228 , 230 , 231 , 232 ,
  234 , 235 , 237 , 238 , 239 , 241 , 242 , 243 , 245 , 246 , 248 , 249 , 250 , 252 , 253 , 255
};

byte led_cold = 3;                                    //Холодный светодиод
byte led_heat = 5;                                    //Теплый светодиод
byte adc = 5;                                         //Аналоговый вход
word Step_light;                                      //Текущий замер переменного резистора
byte Bright_cold;                                     //Яркость холодного светодиода
byte Bright_heat;                                     //Яркость теплого светодиода

void setup() {
  //Настраиваем пины на выход
  pinMode(led_cold, OUTPUT);
  pinMode(led_heat, OUTPUT);
  //Настраиваем АЦП
  analogReference(DEFAULT);
  //Делаем первый замер
  Step_light = analogRead(adc);
}

void loop() {
  //Текущий замер переменного резистора
  Step_light = analogRead(adc);
  
  //Вычисляем значения яркости для обоих лент в зависимости от положения регулятора
  if (Step_light < 256) {
    Bright_cold = Step_light ; Bright_heat = 0;    // проверяет условие, выполняет если верно
  } else if (Step_light > 255 && Step_light < 512) {
    Bright_cold = 255 ; Bright_heat = Step_light - 256;  // если неверно, проверяет новое
  } else if (Step_light > 511 && Step_light < 768) {
    Bright_cold = 767 - Step_light; Bright_heat = 255;  // если неверно, проверяет новое
  } else {
    Bright_cold = 0 ; Bright_heat = 1023 - Step_light; // если неверно, выполняет то, что ниже
  }
  
  //Отправляем данные яркости на выходы ШИМ, предварительно получив значения из таблицы экспонент
  analogWrite(led_cold, TAB_BRIGHTS[Bright_cold]);
  analogWrite(led_heat, TAB_BRIGHTS[Bright_heat]);
  
}
